package djmil.cordacheckers.states;

import java.security.PublicKey;
import java.util.List;
import java.util.UUID;

import djmil.cordacheckers.contracts.GameProposalContract;
import net.corda.v5.base.annotations.ConstructorForDeserialization;
import net.corda.v5.base.types.MemberX500Name;
import net.corda.v5.ledger.utxo.BelongsToContract;
import net.corda.v5.ledger.utxo.ContractState;

@BelongsToContract(GameProposalContract.class)
public class GameProposalState implements ContractState {

    MemberX500Name sender;
    MemberX500Name recipient;
    Piece.Color recipientColor;
    String message;
    UUID id;
    List<PublicKey> participants;

    // Allows serialisation and to use a specified UUID
    @ConstructorForDeserialization
    public GameProposalState(
        MemberX500Name sender,
        MemberX500Name recipient,
        Piece.Color recipientColor,
        String message,
        UUID id,
        List<PublicKey> participants
    ) {
        this.sender = sender;
        this.recipient = recipient;
        this.recipientColor = recipientColor;
        this.message = message;
        this.id = id;
        this.participants = participants;
    }

    public MemberX500Name getSender() {
        return sender;
    }

    public MemberX500Name getRecipient() {
        return recipient;
    }

    public Piece.Color getRecipientColor() {
        return recipientColor;
    }

    public String getMessage() {
        return message;
    }

    public UUID getId() {
        return id;
    }

    public List<PublicKey> getParticipants() {
        return participants;
    }
}
